import UIKit
import Capacitor

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate, UISceneDelegate {

    var window: UIWindow?

    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
    
        return true
    }

    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
        print("^R^ returned to app");

    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }

    func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey: Any] = [:]) -> Bool {
        // Called when the app was launched with a url. Feel free to add additional processing here,
        // but if you want the App API to support tracking app url opens, make sure to keep this call
        //
        let parameters = CordovaSpotifyRemote.shared.appRemote.authorizationParameters(from: url);
        print("^R^ parameters: ", parameters);
        CordovaSpotifyRemote.shared.accessToken = parameters?["code"]
        CordovaSpotifyRemote.shared.appRemote.connectionParameters.accessToken = parameters?["code"]
        CordovaSpotifyRemote.shared.appRemote.connect();
        return ApplicationDelegateProxy.shared.application(app, open: url, options: options)
    }

    func application(_ application: UIApplication, continue userActivity: NSUserActivity, restorationHandler: @escaping ([UIUserActivityRestoring]?) -> Void) -> Bool {
        // Called when the app was launched with an activity, including Universal Links.
        // Feel free to add additional processing here, but if you want the App API to support
        // tracking app url opens, make sure to keep this call
        return ApplicationDelegateProxy.shared.application(application, continue: userActivity, restorationHandler: restorationHandler)
    }
   

    func scene(_ scene: UIScene, willConnectTo session: UISceneSession, options connectionOptions: UIScene.ConnectionOptions) {
    guard let windowScene = (scene as? UIWindowScene) else { return }
    window = UIWindow(frame: UIScreen.main.bounds)
    window!.makeKeyAndVisible()
    window!.windowScene = windowScene
  }
  //for spotify authorization and authentication flow
    func scene(_ scene: UIScene, openURLContexts URLContexts: Set<UIOpenURLContext>) {
      guard let url = URLContexts.first?.url else { return }
      let parameters = CordovaSpotifyRemote.shared.appRemote.authorizationParameters(from: url)
      if let code = parameters?["code"] {
          CordovaSpotifyRemote.shared.responseTypeCode = code
      } else if let access_token = parameters?[SPTAppRemoteAccessTokenKey] {
          CordovaSpotifyRemote.shared.accessToken = access_token
      } else if let error_description = parameters?[SPTAppRemoteErrorDescriptionKey] {
        print("No access token error =", error_description)
      }
    }
    func sceneDidBecomeActive(_ scene: UIScene) {
      if let accessToken = CordovaSpotifyRemote.shared.appRemote.connectionParameters.accessToken {
          CordovaSpotifyRemote.shared.appRemote.connectionParameters.accessToken = accessToken
          CordovaSpotifyRemote.shared.appRemote.connect()
      } else if let accessToken = CordovaSpotifyRemote.shared.accessToken {
          CordovaSpotifyRemote.shared.appRemote.connectionParameters.accessToken = accessToken
          CordovaSpotifyRemote.shared.appRemote.connect()
      }
    }
    func sceneWillResignActive(_ scene: UIScene) {
      if CordovaSpotifyRemote.shared.appRemote.isConnected {
          CordovaSpotifyRemote.shared.appRemote.disconnect()
      }
    }
}
