const exec = cordova.exec;


exports.connectToRemote = async function (redirectURI, clientID, success, err){
    return await exec(success,err,'SpotifyRemote','connectToRemote', [redirectURI,clientID]);
}
exports.builtInAuthConnect = async function (redirectURI, clientID, success, err){
    return await exec(success,err,'SpotifyRemote','builtInAuthConnect', [redirectURI,clientID]);
}
exports.disconnectRemote = function(success, err){
    return exec(success,err,'SpotifyRemote', 'disconnectRemote', []);
}
exports.addToLibrary = function(uri, success, err){
    return exec(success, err, 'SpotifyRemote', 'addToLibrary', [uri]);
}
exports.removeFromLibrary = function(uri, success, err){
    return exec(success, err, 'SpotifyRemote', 'removeFromLibrary', [uri]);
}
exports.play = async function (trackUri, success, err) {
    if (!trackUri) {
        throw new ReferenceError("trackUri parameter is null");
    }
    return await exec(success,err,'SpotifyRemote','play', [trackUri]);
}
exports.getCurrentTrack = function (success, err){
    return exec(success,err,'SpotifyRemote','getCurrentTrack', []);
}
exports.queueSong =  function (trackUri, success, err) {
    if (!trackUri) {
        throw new ReferenceError("trackUri parameter is null");
    }
    return  exec(success,err,'SpotifyRemote','queueSong', [trackUri]);
}
exports.queueTracks =  function (trackUris, success, err) {
    return  exec(success,err,'SpotifyRemote','queueTracks', [trackUris]);
}
/**
 * First track from the URIS will be the first to play
 */
exports.queueTracksNPlay =  function (trackUris, success, err) {
    return  exec(success,err,'SpotifyRemote','queueTracksNPlay', [trackUris]);
}
exports.pause = function (success, err){
    return exec(success,err,'SpotifyRemote','pause', []);
}
exports.resume = function (success, err){
    return exec(success,err,'SpotifyRemote','resume', []);
}
exports.skipNext = function (success, err){
    return exec(success,err,'SpotifyRemote','skipNext', []);
}
exports.skipPrevious = function (success, err){
    return exec(success,err,'SpotifyRemote','skipPrevious', []);
}
exports.shuffle = function (success, err){
    return exec(success,err,'SpotifyRemote','shuffle', []);
}

exports.openSearch = function (success, err){
   return exec(success, err, 'SpotifyRemote', 'openSearch', []);
}
exports.openUserPlaylist = function (success, err){
    return exec(success, err, 'SpotifyRemote', 'openUserPlaylist', []);
 }
exports.openSong = function (success, err, songUrl){
    return exec(success, err, 'SpotifyRemote', 'openSong', [songUrl]);
 }
 exports.openArtist = function (success, err, artistUrl){
    return exec(success, err, 'SpotifyRemote', 'openArtist', [artistUrl]);
 }
 exports.openAlbum = function (success, err, albumUrl){
    return exec(success, err, 'SpotifyRemote', 'openAlbum', [albumUrl]);
 }